import { OnInit, SimpleChanges, OnChanges, EventEmitter } from '@angular/core';
import { NgxFishboneDiagramService } from './ngx-fishbone-diagram.service';
import * as i0 from "@angular/core";
export declare class NgxFishboneDiagramComponent implements OnInit, OnChanges {
    private svc;
    data: any;
    showDowloadButton: boolean;
    btnClass: string;
    btnText: string;
    selected: EventEmitter<string>;
    svg: any;
    force: any;
    root: any;
    node: any;
    link: any;
    nodeIdx: number;
    margin: number;
    nodes: any[];
    links: any[];
    width: number;
    height: number;
    constructor(svc: NgxFishboneDiagramService);
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    clear(): void;
    restart(): void;
    setupNodes(): void;
    /**
     *  buildNodes is a function to rebuild the node list and pad all the nodes with layout directives.
     *  For the layout and forces to work properly, we use a variety of node properties like horizontal,
     *  vertical, region, depth, tail among others.
     * */
    buildNodes(node: any): any;
    /**
     * tick is the actual force layout method. Force is a simulation that happens in
     * steps. At each step, a `tick` event is generated. We connect the event to this
     * method. In this method, we compute the locations of each node based on the forces
     * and position them accordingly.
     * */
    tick(): void;
    calculateXY(d: any, k: number): void;
    defaultArrow(svg: any): void;
    linkDistance(l: any): number;
    nodeClicked(d: any, i: any): void;
    downloadImage(): void;
    simulationDone(): void;
    wrap(selectionList: any, width: number): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgxFishboneDiagramComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgxFishboneDiagramComponent, "ngx-fishbone-diagram", never, { "data": "data"; "showDowloadButton": "showDowloadButton"; "btnClass": "btnClass"; "btnText": "btnText"; }, { "selected": "selected"; }, never, never>;
}
